<?php
namespace Passport\Src;

use Dever;
use Passport\Src\Lib\Base;

class User extends Base
{
    private $user;
    public function __construct()
    {
        parent::__construct();
        $this->init();
    }

    public function init()
    {
        if (!$this->user) {
            $this->user = $this->info();

            $url = Dever::url();
            if (!$this->user && (strpos($url, 'my/') !== false || strpos($url, 'forum/post') !== false)) {
                return Dever::load('passport/login.location');
            }

            if ($this->user) {
                $this->user['msgnum'] = 0;
            }
        }

        return $this->user;
    }

    public function data()
    {
        if ($this->user) {
            $this->user['link'] = Dever::url('user/info', 'main');
            $this->user['link'] = Dever::url('forum/list?uid=' . $this->user['id'], 'main');
        }
        return $this->user;
    }

    public function check()
    {
        if (!$this->user) {
            Dever::alert('请先登录', true);
        }
    }

    public function updateInfo()
    {
        $this->check();

        //$update['set_mobile'] = Dever::input('mobile');
        $update['set_username'] = Dever::input('username');
        $update['set_avatar'] = Dever::input('avatar') ? Dever::input('avatar') . '?v=' . time() : $this->user['avatar'];
        $update['where_id'] = $this->user['id'];
        $sex = Dever::input('sex');

        if ($sex == '男') {
            $update['set_sex'] = 1;
        } elseif ($sex == '女') {
            $update['set_sex'] = 2;
        } else {
            $update['set_sex'] = 0;
        }

        if ($update['set_avatar']) {
            $update['set_avatar'] = $this->saveAvatar($update['set_avatar']);
        }

        Dever::load('passport/user-update', $update);

        $this->user = $this->save($this->user['id']);

        return true;
    }

    public function updateAvatar()
    {
        $this->check();

        $update['set_avatar'] = Dever::input('avatar') ? Dever::input('avatar') . '?v=' . time() : false;
        $update['where_id'] = $this->user['id'];

        if ($update['set_avatar']) {
            $update['set_avatar'] = $this->saveAvatar($update['set_avatar']);

            Dever::load('passport/user-update', $update);

            $this->user = $this->save($this->user['id']);
        }

        return true;
    }

    public function updateWeixin()
    {
        $this->check();

        Dever::load('passport/user-update', array('where_id' => $this->user['id'], 'set_weixin' => 1));

        return true;
    }
}
